#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct s_drvo {
	int broj;
	int treca_cifra;
	struct s_drvo *levi, *desni;
} DRVO;

#define novi(x) x = (DRVO *)malloc(sizeof(DRVO))

int brojCifara(int broj) {
	int i = 0;
	while (broj > 0) {
		broj = broj / 10;
		i++;
	}
	return i;
}

int trecaCifra(int broj) {
	int i = 0;
	if (brojCifara(broj) < 3) return 0;
	while (i < 2) {
		broj = broj / 10;
		i++;
	}
	return broj % 10;
}

void dodaj(DRVO **p, int brojj) {
	DRVO *temp, *pom1, *pom2;
	novi(temp);
	if (!temp) {
		printf("Greska pri alokaciji memorije.\n");
		exit(0);
	}
	temp->broj = brojj;
	temp->treca_cifra = trecaCifra(brojj);
	temp->levi = temp->desni = NULL;
	if (!(*p)) *p = temp;
	else {
		pom1 = *p;
		while (pom1) {
			pom2 = pom1;
			if (trecaCifra(brojj) < pom1->treca_cifra) pom1 = pom1->levi;
			else pom1 = pom1->desni;
		}
		if (trecaCifra(brojj) < pom2->treca_cifra) pom2->levi = temp;
		else pom2->desni = temp;
	}
}

void ispis(DRVO *p) {
	if (p) {
		ispis(p->desni);
		printf("%d, %d\n", p->broj, p->treca_cifra);
		ispis(p->levi);
	}
}

int brojElemenata(DRVO *p, int x) {
	if (p) {
		if ((p->broj < x) && (p->treca_cifra > 2) && (p->treca_cifra < 8)) return 1 + brojElemenata(p->levi, x) + brojElemenata(p->desni, x);
		else return 0 + brojElemenata(p->levi, x) + brojElemenata(p->desni, x);
	}
	else return 0;
}

main() {
	DRVO *p = NULL;
	int b, brojj, i, x;
	scanf("%d", &b);
	for (i = 0; i < b; i++) {
		scanf("%d", &brojj);
		dodaj(&p, brojj);
	}
	printf("----------\n");
	ispis(p);
	printf("----------\n");
	scanf("%d", &x);
	printf("Ukupno brojeva manjih od %d sa trecom cifrom izmedju 2 i 8 je: %d\n", x, brojElemenata(p, x));
}
	


